﻿$newDisplayVersion = "3.1.0.2058"
$newversion = 50397184
$installerKeyName = "{3763D09F-65C6-41B4-BA69-48AFC85D305C}"
$packageName = "PowerGUI" 
$downloadUrl = "http://community-downloads.quest.com/powergui/Release/3.1/PowerGUI.3.1.0.2058.msi"
#NOTE: PowerGUI install/uninstall info located at 
# HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{3763D09F-65C6-41B4-BA69-48AFC85D305C}

$processor = Get-WmiObject Win32_Processor
$is64bit = $processor.AddressWidth -eq 64
$mydir = (Split-Path -parent $MyInvocation.MyCommand.Definition)
$contentDir = ($mydir | Split-Path | Join-Path -ChildPath "content")
$binDir = ($mydir | Split-Path | Join-Path -ChildPath "bin")
$toolsDir = ($mydir | Split-Path | Join-Path -ChildPath "tools")
$shortcutTarget = Join-Path $binDir '$packageName.exe'
$msiInstallLoggingArgs = "/lvoicewarmupx `"$toolsDir\${packageName}${newDisplayVersion}_install.log`""

$errorActionPreference = "stop"

Import-Module "$toolsDir\DeploymentUtils.psm1"
		
function Main() {
	try {

		try {
			
			#first, just blindly attempt to install
			Install-PowerGUI
		} catch {
			Write-Warning "Failed to install, attempting to uninstall..."
			#We got an error during install, so check to see if we need to uninstall, than re-attempt install
			if((Uninstall-Conditionally -installerKeyName $installerKeyName `
										-newDisplayVersion $newDisplayVersion `
										-newVersion $newversion `
										-packageName $packageName `
										-logDir $toolsDir
			)) {
				#if the uninstall returns true, proceed to attempt another install
				Install-PowerGUI
			}
		}

	} catch {
		Write-ChocolateyFailure $packageName "$($_.Exception.Message)"
		throw 
	}
}

function Install-PowerGUI() {
	Install-ChocolateyPackage -packageName $packageName `
					-fileType 'msi' `
					-url "$downloadUrl" `
					-silentArgs "/quiet $msiInstallLoggingArgs"

}


Main
